# -*- coding: utf-8 -*-
from odoo.upgrade import util


def migrate(cr, version):
    util.fixup_m2m(
        cr,
        "oe_database_module_mapping_pricelist_rel",
        "openerp_enterprise_module_mapping",
        "product_pricelist",
        "mapping_id",
        "pricelist_id",
    )
    util.fixup_m2m(
        cr,
        "oe_database_module_dep_rel",
        "openerp_enterprise_database_module",
        "openerp_enterprise_database_module",
        "module_id",
        "dep_id",
    )
    util.fixup_m2m(
        cr,
        "oe_database_user_rel",
        "openerp_enterprise_database",
        "res_users",
        "database_id",
        "user_id",
    )
    util.fixup_m2m(cr, "account_analytic_tag_sale_order_rel", "account_analytic_tag", "sale_order")

    util.remove_field(cr, "sale.subscription", "maintenance_open")
    # Column has already been removed on the table
    util.remove_field(cr, 'crm.team', 'parent_id', drop_column=False)

    cr.execute("""DELETE FROM ir_ui_view WHERE id = 10995""")

    # Update convert to lead server action
    cr.execute("""
        UPDATE ir_act_server SET code = '
user = env.user

# dle
#This server action is used in the saas online project in order to convert issues to leads
#There is a standard module to do the opposite, and at the time it was developed, I asked to develop this way also,
#but it was refused because it was "useless" / not a standard need.
#This simple server action provides a help in order to convert an issue to a lead using the default_ key in the context.

conversation = []
for message in list(record.message_ids):
    if message.message_type in ["email", "comment"]:
        author = ("%s<%s>" % (message.author_id.name, message.email_from)) if message.author_id else message.email_from
        conversation.append("----%s, %s, %s----" % ("Mail" if message.message_type == "email" else "Note", message.create_date, author))
        conversation.append(message.body)
values = {
    "name": "[Issue #%s] %s" % (record.id, record.name),
    "partner_id": record.partner_id.id,
    "description": "Created from issue #%s by %s" % (record.id, user.name) + ("\\n\\n%s" % record.description if record.description else ""),
    "user_id": record.partner_id.user_id.id or False,
}
# Add email_from will block the trigger of  _compute_partner_id_values
# add the value only if their is no partner
if not record.partner_id:
  values["email_from"] = record.email_from

lead = env["crm.lead"].sudo().create(values)
lead.message_post(body="\\n\\n".join(conversation))
record.message_post(body="Lead <a href=\\"/web#model=crm.lead&id=%s\\">#%s</a> created from this issue" % (lead.id,lead.id))

try:
    lead.with_user(user=uid).check_access_rule("read")
    action = {
        "type": "ir.actions.act_window",
        "res_model": "crm.lead",
        "res_id": lead.id,
        "view_mode": "form",
        "target": "current",
    }
except Exception:
    pass'
        WHERE id = 2265;
    """)
